/**********************************************************************
 * This file is Copyright 1999-2000 by Alexander E. Mohr.             *
 * In order to use any part of this file, you must comply with the    *
 * license in "LICENSE."                                              *
 *********************************************************************/

#include "headers.h"

LOSS_PROFILE * create_pmf_sample_binomial( int N, double mean, int RUN_TESTS )
{
    int i,j;
    int total;
    LOSS_PROFILE *profile;

    profile = alloc_loss_profile( N );
    
    total = RUN_TESTS;

    for( i = 0; i < total; i++ )
      {
	int count = 0;
	for ( j = 0; j < N; j++ )
	  {
	    if ( drand48() < mean )
	      count++;
	  }
	profile->loss_PMF[count] ++;
      }

    for( j = 0; j <= N; j++ )
      {
	profile->loss_PMF[j] = profile->loss_PMF[j] / (double) total;
	profile->receive_PMF[N-j] = profile->loss_PMF[j];
      }

    printf("Probabilities:\n");
    for( j = 0; j <= N; j++ )
      {
	printf("%3d - %.10f\n", j, profile->loss_PMF[j] );
      }

    return profile;
}
