/**********************************************************************
 * This file is Copyright 1999-2000 by Alexander E. Mohr.             *
 * In order to use any part of this file, you must comply with the    *
 * license in "LICENSE."                                              *
 *********************************************************************/

#include "headers.h"

LOSS_PROFILE * create_pmf_uniform( int N )
{
    int i,j;
    int start, stop;
    LOSS_PROFILE *profile;

    profile = alloc_loss_profile( N );
    
    start = 0;
    stop = N;

    for( j = start; j <= stop; j++ )
      {
	profile->loss_PMF[j] = 1.0/((double)stop - start + 1.0);
	profile->receive_PMF[N-j] = profile->loss_PMF[j];
      }

    printf("Probabilities:\n");
    for( j = 0; j <= N; j++ )
      {
	printf("%3d - %.10f\n", j, profile->loss_PMF[j] );
      }

    return profile;
}
