/**********************************************************************
 * This file is Copyright 1999-2000 by Alexander E. Mohr.             *
 * In order to use any part of this file, you must comply with the    *
 * license in "LICENSE."                                              *
 *********************************************************************/

#ifndef ULP_PROTO_H
#define ULP_PROTO_H

// memory.c
void check_block( void * block );
UC_ENTRY * alloc_rd_entry( void );
void free_rd_entry( UC_ENTRY * block );
LOSS_PROFILE * alloc_loss_profile( int N );
void free_loss_profile( LOSS_PROFILE * block );
ASSIGNMENT * alloc_assignment( CONFIG_DATA * config );
void free_assignment( ASSIGNMENT * block );
UC_CURVE * alloc_uc_curve( void );
void free_uc_curve( UC_CURVE * block );
UC_ENTRY * alloc_uc_entry( void );
void free_uc_entry( UC_ENTRY * block );

// read_ulp.c
UC_CURVE *read_ulp_data_file( CONFIG_DATA * config );

// util.c
void set_uc_slope( UC_ENTRY * current );
UC_ENTRY * copy_uc_entry_list( UC_ENTRY * actual_head );
void convexify( UC_CURVE * uc_curve, CONFIG_DATA * config );
void print_assignment( ASSIGNMENT * assignment,
		       LOSS_PROFILE * profile,
		       CONFIG_DATA * config );
void write_matlab_plot( ASSIGNMENT * assignment,
			LOSS_PROFILE * profile,
			char * file_name,
			double mean);
void psnrs_to_bytes( ASSIGNMENT * assignment,
		     UC_CURVE * uc_curve,
		     CONFIG_DATA * config );

//rectify.c
int utilities_to_code_strength( ASSIGNMENT * assignment,
				UC_CURVE * uc_curve,
				CONFIG_DATA * config );
double get_utility( int bits, UC_ENTRY *uc_entry, CONFIG_DATA * config );
double get_utility_memo( int bits,
			 UC_ENTRY **uc_entry_p,
			 CONFIG_DATA * config );

// pmf_bin.c
LOSS_PROFILE * create_pmf_binomial( int N, double mean );

// pmf_sample_bin.c
LOSS_PROFILE * create_pmf_sample_binomial( int N, double mean, int RUN_TESTS );

// pmf_exp.c
LOSS_PROFILE * create_pmf_exponential( int N, double mean );

// pmf_oexp.c
LOSS_PROFILE * create_pmf_old_exponential( int N, double mean );

// pmf_uni.c
LOSS_PROFILE * create_pmf_uniform( int N );

// alg_new.c
ASSIGNMENT * algorithm_new( UC_CURVE * uc_curve, LOSS_PROFILE * profile, CONFIG_DATA * config);

#endif





