/**********************************************************************
 * This file is Copyright 1999-2000 by Alexander E. Mohr.             *
 * In order to use any part of this file, you must comply with the    *
 * license in "LICENSE."                                              *
 *********************************************************************/

#ifndef ULP_STRUCTS_H
#define ULP_STRUCTS_H

typedef char *				string;
typedef struct loss_profile		LOSS_PROFILE;
typedef struct config_data		CONFIG_DATA;
typedef struct utility_cost_entry	UC_ENTRY;
typedef struct utility_cost_curve	UC_CURVE;
typedef struct assignment_data		ASSIGNMENT;

struct assignment_data
{
  int *		code_strength;
  double *	guide_utility;
  double *	actual_utility;
  int		code_set;
  int		guide_set;
  int		actual_set;
};

struct config_data
{
// Data file entries.
  char *	fileName;
  int		fileFormat;
  int		utility_type;
  int		cost_type;
  int		image_width;
  int		image_height;
  int		image_frames;  // For video/3d decompositions.
  int		image_bits;    // Image data is 8 bit or 16 bit.
  int		is_layered;    // 1 if layered, 0 if interpolation okay.

  int		symbol_size;   // In bits
  int		number_descriptions;
  int		description_length;  // In symbols

  int		number_symbols;
  int		matching;      // Are we matching results?
// Assignment entries
  double	cost_to_use;
};

struct loss_profile
{
  int		number_descriptions;
  double *	loss_PMF;
  double *	receive_PMF;
};

struct utility_cost_curve
{
  UC_ENTRY *	actual_head;
  UC_ENTRY *	convex_head;
};

struct utility_cost_entry
{
  double	cost;     // In bits
  double	utility;
  double	right_slope;
  UC_ENTRY *	prev;     // The previous entry on the UC curve
  UC_ENTRY *	next;     // The next entry on the UC curve.
  int		index;    // The index number.
};

#endif
